!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 2002.08.31 OREject	[Z, GLULX] [REMOVED]
! eject() prints the same number of linefeeds as there are lines on the screen. The 
! routine is best used as a special effect for dividing story parts.  It conveys to the 
! player, a transition between logical breaks in the game (for instance, chapters). It 
! can be called after printing the final lines of a section, and before the first lines 
! of the next. 
! -- N O T E ---------------------------------------------
! This module does not function on all interpreters as it was designed.  The 
! ORTransition module does the same job in a different manner and it is recommended
! that apps utilize that routine instead. It has therefore been removed from the 
! ORLibrary.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!--------------------------------------------------------------------------------------
! Created by Jim Fisher
! AutoDep:	none
!--------------------------------------------------------------------------------------
! The general use of the routine is as follows:
!	1) Text of Section A is printed.
!	2) eject() scrolls Section A to the top of the screen and then prompts [MORE]
!		After user presses a key, Section A is scrolled off.
!	3) Text of Section B is then printed on a clear screen.
!--------------------------------------------------------------------------------------
! To register this module with your library, add the line:
!
!		#include "OREject";					!Constant USE_OREject; 
!	
!	to the library header file (OR_Library_Include).  To use in a game, add the line:
!
!		Constant USE_OREject; to the game file;
!
!	to the game file;
!--------------------------------------------------------------------------------------
! Revision History
! 2001.04.01	Initial Creation
! 2002.02.11	Added Glulx support
! 2002.02.26	Modified to fit new template.
! 2002.04.08	Re-evaluated this module and its functionality on terps other than Frotz.
!				Removed the final screen clear.
! 2002.08.31	Removing this module from the ORLibrary proper and placing in the ORArchive.zip file
!--------------------------------------------------------------------------------------
#ifdef USE_OREject; message "          Processing library extension OREject...";
!--------------------------------------------------------------------------------------
! D E P E N D A N C I E S   section   (for bringing in dependant modules)
!--- sample forced include---   #ifndef USE_<REPLACEWITHINCLUDENAME>; Constant USE_<REPLACEWITHINCLUDENAME>; message "          ****Forcing inclusion of <REPLACEWITHINCLUDENAME>****"; #include "<REPLACEWITHINCLUDENAME>"; #endif; 
!--- #ifndef TARGET_GLULX; default WORDSIZE 2; #ifnot;default WORDSIZE 4; #endif; !--for GLULX compatability
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#ifdef REPLACEPOINT; #ifndef OREject_DONEREPLACE; constant OREject_DONEREPLACE; 
!--------------------------------------------------------------------------------------
! R E P L A C E   section (for code that preceeds the inclusion of PARSER)
!--------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------
#endif;#endif;#ifdef MESSAGEPOINT; #ifndef OREject_DONEMESSAGE; constant OREject_DONEMESSAGE; 
!--------------------------------------------------------------------------------------
! M E S S A G E   section (for code that falls between PARSER and VERBLIB )
!--- Uncomment to check for OREnglish--- #ifndef OREnglish; message "ERROR!!!! OREject requires the OREnglish file.";#endif; 
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef CODEPOINT; #ifndef OREject_DONECODE;constant OREject_DONECODE; 
!--------------------------------------------------------------------------------------
! C O D E   section (for code that falls between VERBLIB and GRAMMAR)
!--------------------------------------------------------------------------------------
	system_file;
	[eject height t;
	#ifdef TARGET_GLULX;
			glk_window_get_size(gg_mainwin,gg_arguments, gg_arguments+WORDSIZE);
			! window_get_size
			height = gg_arguments-->1;
	#ifnot;
			@loadb $20 0 -> height;		!capture the screen height
			height=height;	
	#endif;
		for(t=0:t<height:t++) new_line; !print"^"; !spitout
	!------------------------------------------------------------------------
	! This code has been removed.  It only seems to work on Frotz based 
	! terps.  GLK terps such as WinNitfol and GLULXE apparently render all
	! text first then allow the more prompt to occur during display.  This 
	! means the screen actually clear without the user ever getting to answer 
	! a more prompt.  An oddball [More] is better than missing text...
	!------------------------------------------------------------------------
	!#ifdef TARGET_GLULX;
	!	glk_window_clear(); ! window_clear
	!#ifnot;
	!	@erase_window -2;				!the screen is now clear.  Call erase window to 
	!#endif;
		
		
	];
!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef GRAMMARPOINT; #ifndef OREject_DONEGRAMMAR; constant OREject_DONEGRAMMAR; #ifdef OREject_DONEGRAMMAR; #endif; !--just to supress warning
!--------------------------------------------------------------------------------------
! G R A M M A R   section (for code that follows the inclusion of GRAMMAR)
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#endif; #endif; #endif;